function [betaR,seS,fOptim,rAdj]=fComb(actual,forecasts,hForward,printIndex);
% combination regression
% for formulas on restricted coefficient estimates and their variances see
% eg 
[T,k]=size(forecasts);
r=1; R=ones(1,k);
beta=pinv(forecasts'*forecasts)*forecasts'*actual;
betaR=beta+pinv(forecasts'*forecasts)*R'*pinv(R*pinv(forecasts'*forecasts)*R')*(r-R*beta);
fOptim=forecasts*betaR; 
e=actual-forecasts*betaR; sig2=mean(e.^2); rAdj=1-(sum(e.^2)/(T-k))/var(actual);
olsVcv=sig2*(pinv(forecasts'*forecasts)-pinv(forecasts'*forecasts)*R'*pinv(R*pinv(forecasts'*forecasts)*R')*R*pinv(forecasts'*forecasts) ); 
olsStErr=sqrt(diag(olsVcv));
%robRegs=forecasts(:,1:end-1)-repmat(forecasts(:,end),1,k-1); robLHS=actual-forecasts(:,end);
if hForward>1;
   [junk,junk,nwM,junk]=olshac(actual,forecasts,hForward-1,0,3); 
else;
   results=hwhite_mine(actual,forecasts); nwM=results.V;
end;
nwVcv=nwM-nwM*R'*pinv(R*nwM*R')*R*nwM; nw=sqrt(diag(nwVcv));
seS=[olsStErr nw];
if printIndex==1; labs=[];
   for i=1:k; labs=strvcat(labs,strcat('F''cast ',int2str(i)));end;
   regprint(betaR,labs(1:k-1,:),zeros(k,1),nwM,e,1,T,[1-sig2/var(actual);rAdj]); 
end; 
