function [hac,k]=hac(u,fixk,prewhite,kernel);

% computes long run variance
% kernel =1 use Parzen
% kernel =2 use QS
% kernel =3 use NW
% fixk=-1 uses Andrews automatic bandwidth selection
% fixk > 0 uses the user specified bandwidth
% prewhite == 1 does (AR(1)) prewhitening

[T,nreg]=size(u);
rho=zeros(nreg,1); sigma=zeros(nreg,1);
d=zeros(nreg,nreg); beta=zeros(nreg,nreg);

if prewhite ==1;
	v=u;
	reg=u(1:T-1,:);  % matrix of lagged variables
	for i=1:nreg;
		beta(:,i)=reg\u(2:T,i);  % this is the same as regessing y(t) on x;
		v(2:end,i)=u(2:T,i)-reg*beta(:,i);  % these are the prewhitened residuals
	end;
	v=v(2:end);   % after AR(1) prewhitening we loose the first obs.
else;
	v=u;
end;

T1=size(v,1);
switch kernel
    case 1; [k,w]=parzen(v,fixk);
    case 2; [k,w]=qs(v,fixk);
    otherwise; [k,w]=nw(v,fixk);
end;


vcv=v'*v;
for i=1:length(w);
	cov1=v(i+1:T1,:)'*v(1:T1-i,:);
	cov2=v(1:T1-i,:)'*v(i+1:T1,:);
	vcv=vcv+w(i)*(cov1+cov2);
end;
vcv=vcv/(T1-nreg);

% recoloring
if prewhite == 1; hac=inv(eye(nreg)-beta)*vcv*(inv(eye(nreg)-beta))';
else; hac=vcv; 
end;
