function [rAdj,fStatMZ,pValMZ] = mzReg(actual,forecasts,hForward,printIndex);
% carries out the Mincer-Zarnowitz regression
% fStatMZ 1st column ols 2nd NW/White
%
[T,k]=size(forecasts);
R=eye(2); r=[0;1];
for i=1:k;
    indepMZ=[ones(size(actual)) forecasts(:,i)];
    betaMZ=indepMZ\actual ;
    e=(actual-indepMZ*betaMZ); sume2=sum(e.^2); 
    if hForward>1; [junk,junk,nwMi,junk]=olshac(actual,indepMZ,hForward-1,0,3); 
    else; results=hwhite_mine(actual,indepMZ); nwMi=results.V; 
    end; 
    rAdj(i,1)=1-(sume2/(T-2))/var(actual); rsq=1-var(e)/var(actual);
    olsVar=mean(e.^2)*inv(indepMZ'*indepMZ); 
    fStatMZ(i,1)=(r-R*betaMZ)'*pinv(R*olsVar*(R'))*(r-R*betaMZ);
    fStatMZ(i,2)=(r-R*betaMZ)'*pinv(R*nwMi*(R'))*(r-R*betaMZ);
    if printIndex==1; 
        regprint(betaMZ,strvcat('Constant',strcat('F''cast ',int2str(i))),[0;0],nwMi,e,1,T,[rsq;rAdj(i)]); 
    end;
end;
pValMZ=1-chi2cdf(fStatMZ,2);
