% ---------------------------------------------------------------------------
%      MKLAGS.M          10/14/02    (after MKLAGS.PRC    JHS 11/30/95 )                            
% ---------------------------------------------------------------------------
%  no fname
function results=mklagsMine(x,px);
[nRows,nCols]=size(x); [nRows,nCols]=size(x); xl=[]; xlag=[];
for i=1:nCols;
    xli=lagmat2(x(:,i),px(1,i),px(2,i));
    xlagi=( px(1,i) : (px(2,i)) )';
    xl=[xl xli]; xlag=[xlag; xlagi]; 
end;
if min(size(xl))>1;
   selCond=~isnan(sum(xl'));
else;
   selCond=~isnan(xl');
end;   

xl=selif(xl,selCond');   
results.xl=xl;
results.xlag=xlag;
% %test proc 
% nobs=10; x=(1:nobs)'*ones(1,3);
% px=[[1;3],[0;0],[1;1]];
% fname=strvcat('a','b','c'); [xl,xname]=mklags(x,px,fname);

% ---------------------------------------------------------------------------
%            LAGMAT.M     10/14/02   (after JHS lagmat.prc)                   
% ---------------------------------------------------------------------------
%     creates matrix of lags.  Positive lag is lag 

function z=lagmat2(x,k1,k2); 
[nRows,nCols]=size(x);
z=repmat(nan,nRows,nCols*(k2-k1+1)); ik=1;
for i=k1:k2 
    if i>=0;
        z((i+1):nRows,ik:(ik+nCols-1))=x(1:(nRows-i),:);
    else;
        z(1:(nRows+i),ik:(ik+nCols-1))=x((-i+1):nRows,:);
    end;
    ik=ik+nCols; 
end;

function x=selif(y,cond);
% PURPOSE: select values of x for which cond is true
% -----------------------------------------------------
% USAGE: x = selif(y,cond)
%  where    y = input vector 
%        cond = a vector of 0,1 values  
% -----------------------------------------------------
% RETURNS: x = y(cond == 1)
% ----------------------------------------------------- 
% NOTE: a Gauss compatability function
% -----------------------------------------------------
% SEE ALSO: delif, indexcat

% written by:
% James P. LeSage, Dept of Economics
% University of Toledo
% 2801 W. Bancroft St,
% Toledo, OH 43606
% jpl@jpl.econ.utoledo.edu
       
% Select values of x for which cond is true
x=y(cond==1,:);
return;

